<?php
define('IN_PHPBB', true);
define('BB_SCRIPT', 'blog');
define('BB_ROOT', './');
require(BB_ROOT .'common.php');
include(INC_DIR .'bbcode.php');
include(INC_DIR .'functions_blog.php');
require(INC_DIR .'recaptchalib.php');
require(INC_DIR .'functions_validate.php');

$user->session_start();
$blog = new Blog();
$blog->get_tag_cloud();
$blog->get_category_list();
$mode = htmlspecialchars(request_var('mode', ''));
$post_add = (bool) @$_REQUEST[BLOG_POST_ADD];
$search_mode = (string) @$_REQUEST[BLOG_SEARCH_MODE];
$mode_start  = isset($_GET['start']) ? abs(intval($_GET['start'])) : 0;
$blog_id = isset($_GET[BLOG_TOPIC_URL]) ? (int) $_GET[BLOG_TOPIC_URL] : 0;
$post_id  = (!$blog_id && isset($_GET[BLOG_POST_URL])) ? (int) $_GET[BLOG_POST_URL] : 0;
$checkComm = isset($_GET['checkComm']) ? $_GET['checkComm'] : false;
$start = ($mode_start) ? $mode_start : 0;
$per_page = '20';
$posts_per_page = '3';
$view_per_page = ($mode == 'view') ? '1' : $per_page;
$view_start = ($mode == 'view') ? '0' : $start;
$join_sql = $join_select = $JoinSearch = $WhereSearch = $url_mode = '';
if(!$checkComm)
{
	$orig_word = array();
	$replacement_word = array();
	obtain_word_list($orig_word, $replacement_word);
	
	switch ($mode)
	{
		case 'view':
			if(empty($blog_id) && empty($post_id))
			{
				bb_die($lang['SELECT_A_ID']);
			}	
			if ($blog_id)
			{
				$sql = "SELECT b.blog_cat_id as category_id, b.*, c.*
					FROM ". BB_BLOG_TOPICS ." b, ". BB_BLOG_CAT ." c
					WHERE b.blog_id = $blog_id
						AND c.blog_cat_id IN(b.blog_cat_id)
					LIMIT 1";
			}
			else if ($post_id)
			{
				$sql = "SELECT b.blog_cat_id as category_id, b.*, r.blog_reply_time, c.*
					FROM ". BB_BLOG_TOPICS ." b, ". BB_BLOG_REPLEY ." r, ". BB_BLOG_CAT ." c
					WHERE r.blog_reply_id = $post_id
						AND b.blog_id = r.blog_id
						AND c.blog_cat_id IN(b.blog_cat_id)
					LIMIT 1";
			}
			else
			{
				bb_die($lang['TOPIC_POST_NOT_EXIST']);
			}

			if (!$b_data = DB()->fetch_row($sql))
			{
				bb_die($lang['TOPIC_POST_NOT_EXIST']);
			}
			if (!empty($b_data['category_id']))
			{
				$category_id = explode(',', $b_data['category_id']);

				if(!empty($category_id))
				{
					$is_auth = $blog->auth(AUTH_ALL, ''.implode(',', $category_id).'', $userdata);
				}
			}
			if (!$is_auth['blog_cat_auth_read'])
			{
				$message = sprintf($lang['SORRY_AUTH_READ'], $is_auth['blog_cat_auth_read_type']);
				bb_die($message);
			}
			if (!$is_auth['blog_cat_auth_view'])
			{
				$message = sprintf($lang['SORRY_AUTH_VIEW'], $is_auth['blog_cat_auth_view_type']);
				bb_die($message);
			}
			if (isset($b_data['blog_dost']))
			{
				switch ($b_data['blog_dost'])
				{
					// All
					case '0':
						break;

					// USER
					case '1':
						if (IS_GUEST)
						{
							bb_die('Просмотр доступен Зарегистрированным пользователям');
						}
						break;
						
					// Private
					case '2':
						if (!IS_AM)
						{
							bb_die('Просмотр доступен Приватным пользователям');
						}
						break;
					// MOD
					case '3':
						if (!IS_AM)
						{
							bb_die('Просмотр доступен Модераторам');
						}
						break;

					// ADMIN
					case '5':
						if (!IS_ADMIN)
						{
							bb_die('Просмотр доступен Администраторам');
						}
						break;

					default:
						bb_die('Ошибка, обратитесь к администратору');
				}
			}
			$blog_id = $b_data['blog_id'];
			
			$sqlView = "INSERT INTO ". BUF_BLOG_VIEW ."
				(blog_id,  blog_views) VALUES
				($blog_id, 1)
				ON DUPLICATE KEY UPDATE
				blog_views = blog_views + 1";
			if ( !DB()->sql_query($sqlView) )
			{
				message_die(GENERAL_ERROR, "Could not update blog views.", '', __LINE__, __FILE__, $sql);
			}
			if ($post_id && !empty($b_data['blog_reply_time']) && ($b_data['blog_replies'] + 1) > $posts_per_page)
			{
				$sql = "SELECT COUNT(blog_reply_id) AS prev_posts
					FROM ". BB_BLOG_REPLEY ."
					WHERE blog_id = $blog_id
						AND blog_reply_time >= {$b_data['blog_reply_time']}";

				if ($row = DB()->fetch_row($sql))
				{
					$b_data['prev_posts'] = $row['prev_posts'];
				}
			}
			
			if ($post_id && isset($b_data['prev_posts']))
			{
				$start = floor(($b_data['prev_posts'] - 1) / $posts_per_page) * $posts_per_page;
			}
			$url = "blog.php?mode=view&b=".$b_data['blog_id']."";
			$join_select .= "text.blog_topics_text as text,";
			$join_sql .= "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = top.blog_id)";
			$join_sql .= "LEFT JOIN ".BB_BLOG_TOPICS_TEXT." text ON(text.blog_topics_id = top.blog_id)";
			$join_sql .= "LEFT JOIN ".BB_USERS." u ON(u.user_id = top.blog_autor)";
			$join_sql .= "WHERE top.blog_id = ".$b_data['blog_id']."";
			$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);
			$join_sql .= ($excluded_forums_csv) ? "
				AND top.blog_cat_id NOT IN($excluded_forums_csv)
			" : '';
			
		break;
		
		case 'category':
			if (isset($_POST[BLOG_CAT_URL]) || isset($_GET[BLOG_CAT_URL]))
			{
				$c_result = (isset($_POST[BLOG_CAT_URL])) ? (int) $_POST[BLOG_CAT_URL] : (int) $_GET[BLOG_CAT_URL];
			}else{
				$c_result = false;
			}
			if($c_result)
			{
				$join_select .= "prev.blog_topics_prev as text, prev.blog_topics_img as image,";
				$join_sql .= "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = top.blog_id)";
				$join_sql .= "LEFT JOIN ".BB_BLOG_TOPICS_PREV." prev ON(prev.blog_topics_id = top.blog_id)";
				$join_sql .= "LEFT JOIN ".BB_USERS." u ON(u.user_id = top.blog_autor)";
				$join_sql .= "WHERE top.blog_cat_id LIKE '%". $c_result ."%'";
				$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);
				$join_sql .= ($excluded_forums_csv) ? "
					AND top.blog_cat_id NOT IN($excluded_forums_csv)
				" : '';
				$JoinSearch .= "";
				$WhereSearch .= "WHERE blog_cat_id LIKE '%". $c_result ."%'";
				$WhereSearch .= ($excluded_forums_csv) ? "
					AND blog_cat_id NOT IN($excluded_forums_csv)
				" : '';
				$url = 'blog.php?mode=category&'.BLOG_CATEGORY_URL .$c_result.'';
			}else{
				bb_die($lang['SELECT_A_CAT_ID']);
			}
		break;
		
		case 'tag':
			if (isset($_POST[BLOG_TAG_URL]) || isset($_GET[BLOG_TAG_URL]))
			{
				$t_result = (isset($_POST[BLOG_TAG_URL])) ? prepare_message($_POST[BLOG_TAG_URL]) : prepare_message($_GET[BLOG_TAG_URL]);
			}else{
				$t_result = false;
			}
			if($t_result)
			{
				$join_select .= "prev.blog_topics_prev as text, prev.blog_topics_img as image,";
				$join_sql .= "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = top.blog_id)";
				$join_sql .= "LEFT JOIN ".BB_BLOG_TOPICS_PREV." prev ON(prev.blog_topics_id = top.blog_id)";
				$join_sql .= "LEFT JOIN ".BB_USERS." u ON(u.user_id = top.blog_autor)";
				$t_text = $blog->search_blog($t_result, 3);
				$join_sql .= "WHERE MATCH (tag.blog_tag) AGAINST ('". $t_text ."' IN BOOLEAN MODE)";
				$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);
				$join_sql .= ($excluded_forums_csv) ? "
					AND top.blog_cat_id NOT IN($excluded_forums_csv)
				" : '';
				$JoinSearch .= "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = blog_id)";
				$WhereSearch .= "WHERE MATCH (tag.blog_tag) AGAINST ('". $t_text ."' IN BOOLEAN MODE)";
				$WhereSearch .= ($excluded_forums_csv) ? "
					AND blog_cat_id NOT IN($excluded_forums_csv)
				" : '';
				$url = 'blog.php?mode=tag&'.BLOG_TAGS_URL .urlencode($t_text).'';
			}else{
				bb_die($lang['SELECT_A_TAG']);
			}
		break;
		
		case 'searchIndex':
			if (isset($_POST['searchIndex']) || isset($_GET['searchIndex']))
			{
				$s_result = (isset($_POST['searchIndex'])) ? prepare_message($_POST['searchIndex']) : prepare_message($_GET['searchIndex']);
				$url_mode .= '&searchIndex='.urlencode($s_result);
			}else{
				$s_result = false;
			}
			if (isset($_POST['tit']) || isset($_GET['tit']))
			{
				$s_mode = isset($_POST['tit']) ? (int) $_POST['tit'] : (int) $_GET['tit'];
				$url_mode .= '&tit='.$s_mode;
			}
			if (!empty($_POST['userName']) || !empty($_GET['userName']))
			{
				$s_user_n = !empty($_POST['userName']) ? $_POST['userName'] : $_GET['userName'];
				$s_user_id = $blog->username_search($s_user_n);
				$s_user = get_user_id($s_user_id);
				$url_mode .= '&userName='.urlencode($s_user_n);
			}else{
				$s_user = false;
			}
			if (!empty($_POST['createDate']) || !empty($_GET['createDate']))
			{
				$s_date = !empty($_POST['createDate']) ? $_POST['createDate'] : $_GET['createDate'];
				$time_massiv = explode(" ", $s_date);
				if(!empty($time_massiv[0])) $time_tmp1 = explode(".", $time_massiv[0]); else message_die(GENERAL_MESSAGE, "Ошибка при вводе даты (dmY)");
				if(!$s_time = mktime(0, 0, 0, $time_tmp1[1], $time_tmp1[0], $time_tmp1[2])) message_die(GENERAL_MESSAGE, "Ошибка при вводе даты (mk)");
				$url_mode .= '&createDate='.urlencode($s_date);
			}else{
				$s_time = false;
			}
			if (!empty($_POST['tag']) || !empty($_GET['tag']))
			{
				$s_tag = !empty($_POST['tag']) ? $_POST['tag'] : $_GET['tag'];
				$url_mode .= '&tag='.urlencode($s_tag);
			}else{
				$s_tag = false;
			}
			if (!empty($_POST['category']) || !empty($_GET['category']))
			{
				$s_cat = !empty($_POST['category']) ? $_POST['category'] : $_GET['category'];
				$url_mode .= '&category='.$_POST['category'];
			}else{
				$s_cat = false;
			}
			if($s_result || int_check($s_user) || int_check($s_time) || $s_tag || int_check($s_cat))
			{
				$join_select .= "prev.blog_topics_prev as text, prev.blog_topics_img as image,";
				$join_sql .= "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = top.blog_id)";
				$join_sql .= "LEFT JOIN ".BB_BLOG_TOPICS_PREV." prev ON(prev.blog_topics_id = top.blog_id)";
				$join_sql .= "LEFT JOIN ".BB_USERS." u ON(u.user_id = top.blog_autor)";
				$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);
				if(!empty($s_result))
				{
					$s_text = $blog->search_blog($s_result, 3);
					$join_sql .= !empty($s_mode) ? '' : "LEFT JOIN ".BB_BLOG_TOPICS_TEXT."	t_txt ON (t_txt.blog_topics_id = top.blog_id)";
					$join_sql .= !empty($s_mode) ? "WHERE MATCH (top.blog_title) AGAINST ('". $s_text ."' IN BOOLEAN MODE)" : "WHERE MATCH (t_txt.blog_topics_text) AGAINST ('". $s_text ."' IN BOOLEAN MODE)";
					$join_sql .= ($excluded_forums_csv) ? "
						AND top.blog_cat_id NOT IN($excluded_forums_csv)
					" : '';
				}else{
					$join_sql .= ($excluded_forums_csv) ? "
						WHERE top.blog_cat_id NOT IN($excluded_forums_csv)
					" : "
						WHERE top.blog_id >= 0
					";
				}
				$join_sql .= !empty($s_cat) ? "
					AND top.blog_cat_id = $s_cat
				" : '';
				$join_sql .= !empty($s_user) ? "
					AND top.blog_autor = $s_user
				" : '';
				$join_sql .= !empty($s_time) ? "
					AND top.blog_time >= $s_time
				" : '';
				$join_sql .= !empty($s_tag) ? "
					AND MATCH (tag.blog_tag) AGAINST ('". $s_tag ."' IN BOOLEAN MODE)
				" : '';
				$JoinSearch .= !empty($s_mode) ? '' : "LEFT JOIN ".BB_BLOG_TOPICS_TEXT."	t_txt ON (t_txt.blog_topics_id = blog_id)";
				$JoinSearch .= !empty($s_tag) ? "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = blog_id)" : '';
				if(!empty($s_result))
				{
					$WhereSearch .= !empty($s_mode) ? "WHERE MATCH (blog_title) AGAINST ('". $s_text ."' IN BOOLEAN MODE)" : "WHERE MATCH (t_txt.blog_topics_text) AGAINST ('". $s_text ."' IN BOOLEAN MODE)";
					$WhereSearch .= ($excluded_forums_csv) ? "
						AND blog_cat_id NOT IN($excluded_forums_csv)
					" : '';
				}else{
					$WhereSearch .= ($excluded_forums_csv) ? "
						WHERE blog_cat_id NOT IN($excluded_forums_csv)
					" : "
						WHERE blog_id >= 0
					";
				}
				$WhereSearch .= !empty($s_cat) ? "
					AND blog_cat_id = $s_cat
				" : '';
				$WhereSearch .= !empty($s_user) ? "
					AND blog_autor = $s_user
				" : '';
				$WhereSearch .= !empty($s_time) ? "
					AND blog_time >= $s_time
				" : '';
				$WhereSearch .= !empty($s_tag) ? "
					AND MATCH (tag.blog_tag) AGAINST ('". $s_tag ."' IN BOOLEAN MODE)
				" : '';
				$url = 'blog.php?mode=searchIndex'.$url_mode;
			}else{
				bb_die('Выбирите критерий поиска');
			}
		break;
		
		default:
		case 'page':
			$url = 'blog.php?mode=page';
			$join_select .= "prev.blog_topics_prev as text, prev.blog_topics_img as image,";
			$join_sql .= "LEFT JOIN ".BB_BLOG_TAG." tag ON(tag.blog_topics_id = top.blog_id)";
			$join_sql .= "LEFT JOIN ".BB_BLOG_TOPICS_PREV." prev ON(prev.blog_topics_id = top.blog_id)";
			$join_sql .= "LEFT JOIN ".BB_USERS." u ON(u.user_id = top.blog_autor)";
			$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);
			$join_sql .= ($excluded_forums_csv) ? "
				WHERE top.blog_cat_id NOT IN($excluded_forums_csv)
			" : '';
			$WhereSearch .= ($excluded_forums_csv) ? "
				WHERE blog_cat_id NOT IN($excluded_forums_csv)
			" : '';

		break;
	}

	$query =  "SELECT COUNT(blog_id) as count_blog
		FROM ".BB_BLOG_TOPICS."
		$JoinSearch
		$WhereSearch
		";
		
	if ( !($num = DB()->sql_query($query)) )
	{
		message_die(GENERAL_ERROR, 'Could not obtain blog information', '', __LINE__, __FILE__, $query);
	}
	$cont = DB()->sql_fetchrow($num);
	$count = ( $cont['count_blog'] ) ? $cont['count_blog'] : 0;
	if($count > 0)
	{
		$sql ="
			SELECT 
				top.*,
				tag.*,
				$join_select 
				u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt
			FROM ".BB_BLOG_TOPICS." top 
			$join_sql
			GROUP BY blog_id DESC
			LIMIT $view_start, $view_per_page";
	/*$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);

	$where_sql = ($excluded_forums_csv) ? "
		WHERE top.blog_cat_id NOT IN($excluded_forums_csv)
	" : '';

		$sql ="
			SELECT 
				top.*,
				tag.*,
				$join_select 
				u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt
			FROM ".BB_BLOG_TOPICS." top, ".BB_BLOG_TAG." tag, ".BB_BLOG_TOPICS_PREV." prev, ".BB_USERS." u
			$where_sql
				AND top.blog_id = prev.blog_topics_id
				AND tag.blog_topics_id = top.blog_id
				AND u.user_id = top.blog_autor
			GROUP BY blog_id DESC
			LIMIT $view_start, $view_per_page";*/
		if ( !($result = DB()->sql_query($sql)) )
		{
				message_die(GENERAL_ERROR, 'Could not obtain information', '', __LINE__, __FILE__, $sql);
		}

		$row = DB()->sql_fetchrowset($result);
		$catsearch = DB()->fetch_rowset('SELECT blog_cat_id
			FROM '. BB_BLOG_CAT);
		foreach ($catsearch as $cat)
		{
			$cats[] = $cat['blog_cat_id'];
		}

		foreach ($row as $blog_data)
		{
			$del_btn = $edit_btn = '';
			$this_auth = $blog->auth(AUTH_ALL, $blog_data['blog_cat_id'], $userdata);
			
			$del_btn = ($this_auth['blog_cat_auth_mod'] || ($userdata['user_id'] == $blog_data['blog_autor'] && $this_auth['blog_cat_auth_delete'] && $blog_data['blog_time'] + 3600*3 > TIMENOW));
			$edit_btn = (($userdata['user_id'] == $blog_data['blog_autor'] && $this_auth['blog_cat_auth_edit']) || $this_auth['blog_cat_auth_mod']);

			$rate_width = (!empty($blog_data['blog_rating_sum'])) ? number_format($blog_data['blog_rating_sum']/$blog_data['blog_rating_count'],2)*11 : '0';
			$image = (!empty($blog_data['image'])) ? '<img width="440" height="270" src="'.$blog_data['image'].'" class="attachment-loop-440 wp-blog-image" alt="'.$blog_data['blog_title'].'" title="'.$blog_data['blog_title'].'" />' : '';
			$text = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $blog_data['text'] . '<'), 1, -1));
			$template->assign_block_vars('blog', array(
				'ID'			=>  $blog_data['blog_id'],
				'CAT'			=>  $blog_data['blog_cat_id'],
				'TITLE'			=>  $blog_data['blog_title'],
				'AUTOR_NAME'	=>  profile_url(array('username' => $blog_data['username'], 'user_id' => $blog_data['blog_autor'], 'user_rank' => $blog_data['user_rank'])),
				'AUTOR_AVA'		=>  get_avatar($blog_data['user_avatar'], $blog_data['user_avatar_type'], !bf($blog_data['user_opt'], 'user_opt', 'allow_avatar'), '32', '32'),
				'TEXT'			=>  $text,
				'IMAGE'			=>  $image,
				'DATE_M'		=>  bb_date($blog_data['blog_time'],'M',true),
				'DATE_D'		=>  bb_date($blog_data['blog_time'],'d',true),
				'DATE_Y'		=>  bb_date($blog_data['blog_time'],'Y',true),
				'U_BLOG_NEWS'	=>  'blog.php?mode=view&b='.$blog_data['blog_id'],
				'COMMENT'		=>	$blog_data['blog_replies'],
				'VIEW'			=>	$blog_data['blog_views'],
				'LIKE'			=>	$blog_data['blog_like_count'],
				'RATING_WIDTH'	=>	$rate_width,
				'RATING_SUM'	=>	$blog_data['blog_rating_sum'],
				'RATING_COUNT'	=>	$blog_data['blog_rating_count'],
				'EDIT_BTN'		=>	$edit_btn,
				'EDIT_URL'		=>	make_url('blog_newsadd.php?mode=edit&b='.$blog_data['blog_id']),
				'DELETE_BTN'	=>	$del_btn,
				'DELETE_URL'	=>	make_url('blog_newsadd.php?mode=delete&b='.$blog_data['blog_id']),
			));
			if (!empty($blog_data['blog_cat_id']))
			{
				$category = array_intersect(explode(',', $blog_data['blog_cat_id']), $cats);
				
				if(!empty($category))
				{
					$sql_c = DB()->fetch_rowset('SELECT *
						FROM '. BB_BLOG_CAT ."
						WHERE blog_cat_id IN (".implode(',', $category).")
						ORDER BY blog_cat_order, blog_cat_id");
					foreach ($sql_c as $cat)
					{
						$template->assign_block_vars('blog.cat', array(
							'NAME'		=> $cat['blog_cat_name'],
							'U_CAT'		=> 'blog.php?mode=category&b='.$cat['blog_cat_id'],
						));
					}
				}
			}
			if (!empty($blog_data['blog_tag']))
			{
				if(substr_count($blog_data['blog_tag'], ",")>0){
					$tags = explode(',', $blog_data['blog_tag']);
				}else{
					$tags = explode(' ', $blog_data['blog_tag']);
				}
				foreach ($tags as $tag)
				{
					$template->assign_block_vars('blog.tag', array(
						'TAG'		=> $tag,
						'U_TAG'		=> 'blog.php?mode=tag&b='.$tag,
					));
				}
			}
		}
		switch ($mode)
		{
			case 'view':
				switch ($search_mode)
				{
					case 'username':
						if (isset($_POST['search']) || isset($_GET['search']))
						{
							$s_result = (isset($_POST['search'])) ? $_POST['search'] : $_GET['search'];
						}else{
							$s_result = false;
						}
						if($s_result)
						{
							$username_search = preg_replace('/\*/', '%', clean_username($s_result));
							$joinSQLsearch = "LEFT JOIN ".BB_USERS." u  ON (u.user_id = rep.blog_reply_user_id)";
							//$andSQLsearch = "AND MATCH (u.username) AGAINST ('". search_blog($username_search) ."')";
							$andSQLsearch = "AND u.username LIKE '%". DB()->escape($username_search) ."%'";
							$url = 'blog.php?mode=view&b='.$b_data['blog_id'].'&search='.urlencode($username_search).'&search_mode=username';
						}else{
							bb_die('введите имя пользователя');
						}
					break;
					
					case 'post_text':
						if (isset($_POST['search']) || isset($_GET['search']))
						{
							$s_result = (isset($_POST['search'])) ? prepare_message($_POST['search']) : prepare_message($_GET['search']);
						}else{
							$s_result = false;
						}
						if($s_result)
						{
							$s_text = $blog->search_blog($s_result);
							$joinSQLsearch = "LEFT JOIN ".BB_BLOG_REPLEY_TEXT."	rep_txt ON (rep_txt.blog_reply_id = rep.blog_reply_id)";
							$andSQLsearch = "AND MATCH (rep_txt.blog_reply_text) AGAINST ('". $s_text ."' IN BOOLEAN MODE)";
							//$andSQLsearch = "AND rep_txt.blog_reply_text LIKE '%". $s_result ."%'";
							$url = 'blog.php?mode=view&b='.$b_data['blog_id'].'&search='.urlencode($s_text).'&search_mode=post_text';
						}else{
							bb_die('введите текст сообщения');
						}
					break;
					default:
						$andSQLsearch = $joinSQLsearch ='';
				}	
				$sql = "
					SELECT 
						rep.*,
						rep_html.blog_reply_html, IF(rep_html.blog_reply_html IS NULL, rep_txt.blog_reply_text, NULL) AS text,
						u.username, u.user_rank, u.user_avatar, u.user_avatar_type, u.user_opt
					FROM ".BB_BLOG_REPLEY."				rep
						LEFT JOIN ".BB_BLOG_REPLEY_TEXT."			rep_txt ON (rep_txt.blog_reply_id = rep.blog_reply_id)
						LEFT JOIN ".BB_BLOG_REPLEY_HTML." 			rep_html ON(rep_html.blog_reply_id = rep.blog_reply_id)
						LEFT JOIN ".BB_USERS."						u  ON (u.user_id = rep.blog_reply_user_id)
					WHERE rep.blog_id = ".$b_data['blog_id']."
					$andSQLsearch
					ORDER by rep.blog_reply_id DESC LIMIT $start, $posts_per_page";

				if ( !($result = DB()->sql_query($sql)) )
				{
						message_die(GENERAL_ERROR, 'Could not obtain information', '', __LINE__, __FILE__, $sql);
				}
				$row = DB()->sql_fetchrowset($result);
				$row_num = DB()->fetch_row("
					SELECT COUNT(rep.blog_reply_id) as count_num 
					FROM ".BB_BLOG_REPLEY." rep
					$joinSQLsearch
					WHERE rep.blog_id = ".$b_data['blog_id']."
					$andSQLsearch
					LIMIT 1
				");
				$count_num = $row_num['count_num'];
				if(!$count_num)
				{
					$template->assign_block_vars('post_none', array());
				}
				$i=0;
				foreach ($row as $blog_post)
				{
					$message = $blog->get_parsed_repley($blog_post);
					if($blog_post['blog_reply_user_id']>0)
					{
						$avatar = str_replace('<img', '<img class="avatar" ', get_avatar($blog_post['user_avatar'], $blog_post['user_avatar_type'], !bf($blog_post['user_opt'], 'user_opt', 'allow_avatar'), '42', '42'));
						$name = profile_url(array('username' => $blog_post['username'], 'user_id' => $blog_post['blog_reply_user_id'], 'user_rank' => $blog_post['user_rank']));
					}else{
						if($blog_post['blog_reply_avatar'] != '0')
						{
							$avatar = '<img class="avatar" src="'.$blog_post['blog_reply_avatar'].'" width="42" height="42" />';
						}else{
							$avatar = '<img class="avatar" src="'.BB_ROOT.'images/noavatar.png" width="42" height="42" />';
						}
						$name = $blog_post['blog_reply_user_name'];
					}
					$quote_btn = $edit_btn = '';
					if ($blog_post['blog_reply_user_id'] != BOT_UID)
					{
						// Quote
						$quote_btn = true;
						// Edit
						$edit_btn = (($userdata['user_id'] == $blog_post['blog_reply_user_id'] && $is_auth['blog_cat_auth_edit']) || $is_auth['blog_cat_auth_mod']);
					}
					// Delete
					$delpost_btn = ($blog_post['blog_reply_id'] != $blog_data['blog_first_post_id'] && ($is_auth['blog_cat_auth_mod'] || ($userdata['user_id'] == $blog_post['blog_reply_user_id'] && $is_auth['blog_cat_auth_delete'] && $blog_data['blog_last_post_id'] == $blog_post['blog_reply_id'] && $blog_post['blog_reply_time'] + 3600*3 > TIMENOW)));
					
					$i++;
					$message = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $message . '<'), 1, -1));
					$template->assign_block_vars('postrow', array(
						'ROW_CLASS'     => !($i % 2) ? 'discus' : 'discus2',
						'I'				=> $i,
						'ID'			=> ($count_num - ($i + $start)) + 1,
						'POST_ID'		=> $blog_post['blog_reply_id'],
						'EMAIL'			=> $blog_post['blog_reply_email'],
						'U_NAME'		=> $name,
						'TEXT'			=> $message,
						'TIME'			=> bb_date($blog_post['blog_reply_time'],'d/M/Y H:i'),
						'AVATAR'		=> $avatar,
						'AVATAR_TEXT'	=> $blog_post['blog_reply_avatar'],
						'AVATAR_TEXT_ON'=> empty($blog_post['blog_reply_avatar']) ? true : false,
						'CHECK'			=> ($blog_post['blog_reply_active'] != 0) ? true : false,
						'ACTIVATED'		=> 'blog.php?checkComm='.$blog_post['blog_reply_active_key'].'',
						'URL_POST'		=> make_url(BLOG_MODE_URL . "view". "&" . BLOG_POSTS_URL . $blog_post['blog_reply_id'], true),
						'QUOTE'   		=> $quote_btn,
						'EDIT'    		=> $edit_btn,
						'DELETE'  		=> $delpost_btn,
					));
				}
				($bb_cfg['blog']['captcha_on'] && $bb_cfg['blog']['chek_user'] == 'recaptcha') ? $recaptcha_code = recaptcha_get_html ($recaptcha_public_key, null) : '';   
				$captcha_on = (int) !empty($userdata['session_logged_in']) ? false : $bb_cfg['blog']['captcha_on'];
				if ($userdata['user_level'] == ADMIN || $is_auth['blog_cat_auth_reply'] && !($b_data['blog_cat_status'] == FORUM_LOCKED || $b_data['blog_lock'] == TOPIC_LOCKED))
				{
					$template->assign_vars(array(
						'CHEK_WHO'			=> ($bb_cfg['blog']['captcha_on'] && $bb_cfg['blog']['chek_user']) ? 'Будте внимательны при заполнении email, при постинге необходимо подтвердить комментарий.' : 'Все сообщения без исключения, должны проверятся администратором\модератором', 
						'QUICK_REPLY'		=> true,
						'QUESTS_REPLY'		=> true,
						'QR_POST_ACTION'	=> "blog.php?mode=$mode&b=$blog_id",
						'CAPTCHA_HTML'		=> ($bb_cfg['blog']['captcha_on'] && $bb_cfg['blog']['captcha'] == 'captcha') ? CAPTCHA()->get_html() : '',
						'RECAPTCHA_CODE'	=> ($bb_cfg['blog']['captcha_on'] && $bb_cfg['blog']['captcha'] == 'recaptcha') ? $recaptcha_code : '', 
						'CAPTCHA_IS'		=> $bb_cfg['blog']['captcha'],
						'CAPTCHA_ON'		=> $captcha_on,
					));
				}
				if ($is_auth['blog_cat_auth_post_view'])
				{
					$template->assign_vars(array(
						'POST_ON'		=> true,
					));
				}
				$template->assign_vars(array(
					'VIEW_FALSE'		=> true,
				));
			break;
		}
		switch ($post_add)
		{
			case 'add':
				if(empty($mode))
				{
					bb_die($lang['SELECT_A_MODE']);
				}	
				if(bf($userdata['user_opt'], 'user_opt', 'allow_post'))
				{
					bb_die($lang['RULES_REPLY_CANNOT']);
				}
				else if(!$is_auth['blog_cat_auth_reply'])
				{
					bb_die(sprintf($lang['SORRY_AUTH_REPLY'], strip_tags($is_auth['blog_cat_auth_reply_type'])));
				}
				if ($b_data['blog_lock'] == TOPIC_LOCKED && !$is_auth['blog_cat_auth_mod'])
				{
				   bb_die($lang['TOPIC_LOCKED']);
				}
				$errors = array();
				if(IS_GUEST)
				{
					$avatar		= isset($_POST['avatar']) ? $_POST['avatar'] : '';
					$user_name	= isset($_POST['user_name']) ? $_POST['user_name'] : '';
					$email1		= isset($_POST['email1']) ? $_POST['email1'] : '';
					$email2		= isset($_POST['email2']) ? $_POST['email2'] : '';
					$message	= isset($_POST['message']) ? prepare_message($_POST['message']) : '';
					$email 		= chek_qb_mail($email1)."@".chek_qb_mail($email2);
					$username 	= clean_username($user_name);
							
					if(empty($_POST['user_name']))
					{
						$errors[] = $lang['CHOOSE_A_NAME'];
					}
					else if(validate_username($username))
					{
						$errors[] = validate_username($username);
						$chec_uname = false;
					}else{
						$chec_uname = true;
					}
					if(empty($_POST['email1']) || empty($_POST['email2']))
					{
						$errors[] = $lang['CHOOSE_E_MAIL'];
					}
					else if(validate_email($email, false))
					{
						$errors[] = validate_email($email);
						$chec_email = false;
					}else{
						$chec_email = true;
					}
					if(empty($_POST['message']))
					{
						$errors[] = $lang['EMPTY_MESSAGE'];
					}
					if($bb_cfg['blog']['captcha_on'])
					{
						if($bb_cfg['blog']['captcha'] == 'captcha')
						{
							if (!CAPTCHA()->verify_code())
							{
								$errors[] = $lang['CONFIRM_CODE_WRONG'];
								$captcha = false;
							}else{
								$captcha = true;
							}
						}
						if($bb_cfg['blog']['captcha'] == 'recaptcha')
						{
							$recaptcha_response =  recaptcha_check_answer ($recaptcha_private_key, $client_ip, htmlspecialchars($_POST['recaptcha_challenge_field']), htmlspecialchars($_POST['recaptcha_response_field'])); 	
							if (!$recaptcha_response->is_valid) {
								$error = TRUE;
								$recaptcha_code = recaptcha_get_html ($recaptcha_public_key, $recaptcha_response->error);
								$errors[] = $lang['CONFIRM_CODE_WRONG'];
								$captcha = false;
							}else{
								$captcha = true;
							}	
						}
					}else{
						$captcha = true;
					}	

					if ($user_name && $email1 && $email2 && $message && $captcha && $chec_email && $chec_uname) 
					{
						$check	= base64_encode(generate_code(21));
						$sql	= $blog->add_reply(array(
									'id'		=> $b_data['blog_id'],
									'username'	=> DB()->escape($user_name),
									'email'		=> DB()->escape($email),
									'avatar'	=> DB()->escape($avatar),
									'active'	=> '0',
									'active_key'=> $check,
									'text'		=> $message,
								), false);
						if($sql)
						{
							if($bb_cfg['blog']['chek_user'])
							{	
								include(INC_DIR . 'emailer.class.php');
								$emailer = new emailer($bb_cfg['smtp_delivery']);

								$emailer->from($bb_cfg['board_email']);
								$emailer->replyto($bb_cfg['board_email']);
												
								$emailer->use_template('blog_activate', $bb_cfg['default_lang']);
								$emailer->email_address($email);
								$emailer->set_subject($lang['ACTIVATE_QBOOK']);

								$emailer->assign_vars(array(
									'SITENAME'   => $bb_cfg['sitename'],
									'USERNAME'   => html_entity_decode($user_name),
									'EMAIL_SIG'  => (!empty($bb_cfg['board_email_sig'])) ? str_replace('<br />', "\n", "-- \n" . $bb_cfg['board_email_sig']) : '',
									'U_ACTIVATE' => make_url("blog.php?checkComm={$check}", true),
								));
								$emailer->send();
								$emailer->reset();
							}
							$chek_post_qb = ($bb_cfg['blog']['chek_user']) ? $lang['POST_CONFERM_ON_EMAIL'] : $lang['POST_CONFERM_ON_MOD'];
							message_die(GENERAL_MESSAGE, $lang['MESSAGE_SENT'] . $chek_post_qb . '<br /><br />' . sprintf($lang['CLICK_RETURN_BLOG'], '<a href="blog.php?mode=view&b='.$b_data['blog_id'].'">', '</a>'));		
						}else{
							bb_die("query ERROR");
						}
					}
					$template->assign_vars(array(
						'ADD_AVATAR'	=> $avatar,
						'ADD_USER_NAME'	=> $user_name,
						'ADD_EMAIL1'	=> $email1,
						'ADD_EMAIL2'	=> $email2,
						'MESSAGE'	=> $message,
					));
				}else{
					$message	= isset($_POST['message']) ? prepare_message($_POST['message']) : '';
					if(empty($_POST['message']))
					{
						$errors[] = $lang['EMPTY_MESSAGE'];
					}
					if ($message) 
					{
						$blog->add_reply(array(
							'id'		=> $b_data['blog_id'],
							'text'		=> $message,
							'active'	=> '1',
						));
					}	
				}
				$template->assign_vars(array(
					'ERROR_MESSAGE'   => ($errors) ? join('<br />', array_unique($errors)) : '',
				));
			break;
			
			default:
		}
		$add_news = $images['blog_news_new'];
		$add_news_alt = $lang['BLOG_ADD'];
		$sel_per_page = ($mode == 'view') ? $posts_per_page : $per_page;
		$num_query = ($mode == 'view') ? $count_num : $count;
		$pagination = generate_pagination($url, $num_query, $sel_per_page, $start, false, true);
		$template->assign_vars(array(
				'PAGINATION'			=> $pagination,
				'U_PER_PAGE'			=> $url,
				'PER_PAGE'				=> $sel_per_page,
				'S_FORM_ACTION'			=> $url,
				'PAGE_TITLE'			=> (!isset($b_data['blog_id'])) ? sprintf($lang['BLOG_INDEX'], $bb_cfg['sitename']) : $lang['ENTRY']. ' ' . $b_data['blog_title'],
				'HAS_PARENT_TITLE'  	=> ($mode == 'view') ? true : false,
				'PARENT_TITLE_HREF'		=> ($mode == 'view') ? make_url(BLOG_MODE_URL . "view". "&" . BLOG_URL . $b_data['blog_id'], true) : '',
				'PARENT_TITLE_NAME' 	=> ($mode == 'view') ? htmlCHR($b_data['blog_title']) : '',
				'ADD_NEWS_IMG'			=> $add_news,
				'T_ADD_NEWS'      		=> $add_news_alt,
				'U_ADD_NEWS_BLOG'		=> make_url("blog_newsadd.php", true),
				'CAT_SELECT'			=> $blog->get_category_select(),
				'QR_SEARCH_ACTION'		=> "blog.php?mode=searchIndex",
		));
	}else{
		$template->assign_block_vars('not_blog_news', array());
		$add_news = $images['blog_news_new'];
		$add_news_alt = $lang['BLOG_ADD'];
		$template->assign_vars(array(
				'PAGE_TITLE'			=> (!isset($b_data['blog_id'])) ? sprintf($lang['BLOG_INDEX'], $bb_cfg['sitename']) : $lang['ENTRY']. ' ' . $b_data['blog_title'],
				'HAS_PARENT_TITLE'  	=> ($mode == 'view') ? true : false,
				'PARENT_TITLE_HREF'		=> ($mode == 'view') ? make_url(BLOG_MODE_URL . "view". "&" . BLOG_URL . $b_data['blog_id'], true) : '',
				'PARENT_TITLE_NAME' 	=> ($mode == 'view') ? htmlCHR($b_data['blog_title']) : '',
				'ADD_NEWS_IMG'			=> $add_news,
				'T_ADD_NEWS'      		=> $add_news_alt,
				'U_ADD_NEWS_BLOG'		=> make_url("blog_newsadd.php", true),
				'CAT_SELECT'			=> $blog->get_category_select(),
				'QR_SEARCH_ACTION'		=> "blog.php?mode=searchIndex",
		));
	}
}
	
if($checkComm)
{
	$sql = "SELECT * FROM ".BB_BLOG_REPLEY." WHERE blog_reply_active_key = '".$checkComm."' AND blog_reply_active = '0' LIMIT 1";
	$row = DB()->fetch_row($sql);

	if($checkComm != $row['blog_reply_active_key'] || empty($checkComm)){
		message_die(GENERAL_MESSAGE, $lang['VERIFICATION_EMAIL_ERROR']);
	}else{
		$sql_active ="UPDATE ".BB_BLOG_REPLEY." SET blog_reply_active = '1' WHERE blog_reply_active_key='".$checkComm."'";
		DB()->sql_query($sql_active);
		$refresh = meta_refresh(make_url(BLOG_MODE_URL . "view". "&" . BLOG_POSTS_URL . $row['blog_reply_id'], true) .'#blog-' . $row['blog_reply_id']);
		$info_redirect = $lang['SUCCESSFUL_CONFIRMATION_EMAIL']. '<br />' . $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_VIEW_MESSAGE'], '<a href="'.make_url(BLOG_MODE_URL . "view". "&" . BLOG_POSTS_URL . $row['blog_reply_id'], true).'#blog-'.$row['blog_reply_id'].'">', '</a>') . '<br /><br />' . sprintf($lang['CLICK_RETURN_BLOG'], '<a href="blog.php?mode=view&b='.$row['blog_id'].'">', '</a>');
		message_die(GENERAL_MESSAGE, $info_redirect);
	}
}

$template->assign_vars(array(
	'PAGE_TITLE'		   => sprintf($lang['BLOG_INDEX'], $bb_cfg['sitename']),
	'ON_MORE_URL'	   	   => true,
	'TITLE_MORE_URL'	   => sprintf($lang['BLOG_INDEX'], $bb_cfg['sitename']),
	'U_MORE_URL'		   => make_url("blog.php", true),
));
print_page('blog.tpl');