<?php
if (!defined('BB_ROOT')) die(basename(__FILE__));

class Blog
{
	function add_topic($data, $mode="add", $message = true)
	{
		global $userdata, $blog, $lang;
		if(IS_GUEST) return;
		
		$sync_forums = array();
		
		$query['blog_cat_id']	= @$data['cat_id'];
		$query['blog_title']	= @$data['title'];
		$query['blog_autor']	= $userdata['user_id'];
		$query['blog_time']		= TIMENOW;
		$query['blog_lock']		= @$data['lock'];
		$query['blog_dost']		= @$data['dost'];

		switch ($mode)
		{
			case "add" :
				$sql_insert = DB()->build_array('INSERT', $query);
				$sqls = "INSERT INTO ".BB_BLOG_TOPICS." $sql_insert";
				
				if (!DB()->sql_query($sqls))
				{
					message_die(GENERAL_ERROR, 'Error in blog', '', __LINE__, __FILE__, $query);
				}
				
				$blog_topics_id = DB()->sql_nextid();
				self::add_topic_text(array('blog_topics_id' => $blog_topics_id, 'blog_topics_text' => @$data['text']));
				self::add_topic_tag(array('blog_topics_id' => $blog_topics_id, 'blog_tag' => @$data['tag']));
				self::add_topic_prev(array('blog_topics_id' => $blog_topics_id, 'blog_topics_prev' => @$data['prev'], 'blog_topics_img' => @$data['img']));
				
				$sync_forums[@$data['cat_id']] = true;
				self::update_blog_info('category', array_keys($sync_forums));
				
				if($message)
				{
					$refresh = meta_refresh(make_url(BLOG_MODE_URL . "view". "&" . BLOG_URL . $blog_topics_id, true));
					
					$info_redirect = $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_VIEW_MESSAGE'], '<a href="'.make_url(BLOG_MODE_URL . "view". "&" . BLOG_URL . $blog_topics_id, true).'">', '</a>') . '<br /><br />' . sprintf($lang['CLICK_RETURN_FORUM'], '<a href="'.make_url('blog.php', true).'">', '</a>');
					message_die(GENERAL_MESSAGE, $info_redirect);
				}
			break;
			
			case "edit" :
				$blog_topics_id = $data['blog_id'];
				
				$sql_insert = DB()->build_array('UPDATE', $query);
				$sqls = "
					UPDATE ". BB_BLOG_TOPICS ." SET
						$sql_insert
					WHERE blog_id = $blog_topics_id
					LIMIT 1
				";
				
				if (!DB()->sql_query($sqls))
				{
					message_die(GENERAL_ERROR, 'Error in blog', '', __LINE__, __FILE__, $query);
				}
				
				self::add_topic_text(array('blog_topics_id' => $blog_topics_id, 'blog_topics_text' => @$data['text']),'edit');
				self::add_topic_tag(array('blog_topics_id' => $blog_topics_id, 'blog_tag' => @$data['tag']),'edit');
				self::add_topic_prev(array('blog_topics_id' => $blog_topics_id, 'blog_topics_prev' => @$data['prev'], 'blog_topics_img' => @$data['img']),'edit');
				
				$sync_forums[@$data['cat_id']] = true;
				self::update_blog_info('category', array_keys($sync_forums));
				
				if($message)
				{
					$refresh = meta_refresh(make_url(BLOG_MODE_URL . "view". "&" . BLOG_URL . $blog_topics_id, true));
					
					$info_redirect = $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_VIEW_MESSAGE'], '<a href="'.make_url(BLOG_MODE_URL . "view". "&" . BLOG_URL . $blog_topics_id, true).'">', '</a>') . '<br /><br />' . sprintf($lang['CLICK_RETURN_FORUM'], '<a href="'.make_url('blog.php', true).'">', '</a>');
					message_die(GENERAL_MESSAGE, $info_redirect);
				}
			break;
		}

	}
	static function add_topic_text($data, $mode="add")
	{
		$query['blog_topics_id']	= @$data['blog_topics_id'];
		$query['blog_topics_text']	= @$data['blog_topics_text'];
		
		switch ($mode)
		{
			case "add" :
				$sql_insert = DB()->build_array('INSERT', $query);
				$sql = "INSERT INTO ".BB_BLOG_TOPICS_TEXT." $sql_insert";
			break;
			
			case "edit" :
				$sql = "
					UPDATE ". BB_BLOG_TOPICS_TEXT ." SET
						blog_topics_text = '{$query['blog_topics_text']}'
					WHERE blog_topics_id = '{$query['blog_topics_id']}'
					LIMIT 1
				";
			break;
		}
		
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not insert topic text for blog', '', __LINE__, __FILE__, $sql);
		}
	}

	static function add_topic_tag($data, $mode="add")
	{
		$query['blog_topics_id']	= @$data['blog_topics_id'];
		$query['blog_tag']	= @$data['blog_tag'];
		
		switch ($mode)
		{
			case "add" :
				$sql_insert = DB()->build_array('INSERT', $query);
				$sql = "INSERT INTO ".BB_BLOG_TAG." $sql_insert";
			break;
			
			case "edit" :
				$sql = "
					UPDATE ". BB_BLOG_TAG ." SET
						blog_tag = '{$query['blog_tag']}'
					WHERE blog_topics_id = '{$query['blog_topics_id']}'
					LIMIT 1
				";
			break;
		}
		
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not insert topic tag for blog', '', __LINE__, __FILE__, $sql);
		}
	}
	static function add_topic_prev($data, $mode="add")
	{
		switch ($mode)
		{
			case "add" :
				$query['blog_topics_id']		= @$data['blog_topics_id'];
				$query['blog_topics_prev']		= @$data['blog_topics_prev'];
				$query['blog_topics_img']		= @$data['blog_topics_img'];
				
				$sql_insert = DB()->build_array('INSERT', $query);
				$sql = "INSERT INTO ".BB_BLOG_TOPICS_PREV." $sql_insert";
			break;
			
			case "edit" :
				$query['blog_topics_prev']		= @$data['blog_topics_prev'];
				$query['blog_topics_img']		= @$data['blog_topics_img'];
				
				$sql_insert = DB()->build_array('UPDATE', $query);
				$sql = "
					UPDATE ". BB_BLOG_TOPICS_PREV ." SET
						$sql_insert
					WHERE blog_topics_id = {$data['blog_topics_id']}
					LIMIT 1
				";
			break;
		}
		if (!DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not insert topic prev for blog', '', __LINE__, __FILE__, $sql);
		}
	}

	function add_reply($data, $message = true)
	{
		global $userdata, $lang, $is_auth;
		
		$sync_topics = array();
		
		if(!IS_GUEST)
		{
			$sql_post['blog_id']				= @$data['id'];
			$sql_post['blog_reply_user_id']		= $userdata['user_id'];
			$sql_post['blog_reply_time']		= TIMENOW;
			$sql_post['blog_reply_user_ip']		= USER_IP;
			$sql_post['blog_reply_active']		= @$data['active'];
			
			$sql_insert_post = DB()->build_array('INSERT', $sql_post);
			$sql = "INSERT INTO ".BB_BLOG_REPLEY." $sql_insert_post";
			if (!DB()->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not insert post for blog', '', __LINE__, __FILE__, $sql);
			}
				
			//TEXT
			$next_repley_id = DB()->sql_nextid();
			$sql_text['blog_reply_id']			= $next_repley_id;
			$sql_text['blog_reply_text']		= @$data['text'];	
			
			$sql_insert_text = DB()->build_array('INSERT', $sql_text);
			$sql = "INSERT INTO ".BB_BLOG_REPLEY_TEXT." $sql_insert_text";
			if (!DB()->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not insert post for blog text', '', __LINE__, __FILE__, $sql);
			}
		}else{
			//POST
			$sql_post['blog_id']				= @$data['id'];
			$sql_post['blog_reply_user_id']		= ANONYMOUS;
			$sql_post['blog_reply_user_name']	= @$data['username'];
			$sql_post['blog_reply_time']		= TIMENOW;
			$sql_post['blog_reply_user_ip']		= USER_IP;
			$sql_post['blog_reply_email']		= @$data['email'];
			$sql_post['blog_reply_avatar']		= @$data['avatar'];
			$sql_post['blog_reply_active']		= @$data['active'];		
			$sql_post['blog_reply_active_key']	= @$data['active_key'];		
			
			$sql_insert_post = DB()->build_array('INSERT', $sql_post);
			$sql ="INSERT INTO ".BB_BLOG_REPLEY." $sql_insert_post";
			if (!DB()->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not insert post for blog', '', __LINE__, __FILE__, $sql);
			}
			
			//TEXT
			$next_repley_id = DB()->sql_nextid();
			$sql_text['blog_reply_id']			= $next_repley_id;
			$sql_text['blog_reply_text']		= @$data['text'];	
			
			$sql_insert_text = DB()->build_array('INSERT', $sql_text);
			$sql = "INSERT INTO ".BB_BLOG_REPLEY_TEXT." $sql_insert_text";
			if (!DB()->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not insert post for blog text', '', __LINE__, __FILE__, $sql);
			}
			
		}
		self::update_blog_info('blog', @$data['id']);
		if($message)
		{
			$refresh = meta_refresh(make_url(BLOG_MODE_URL . "view". "&" . BLOG_POSTS_URL . $next_repley_id, true) .'#blog-' . $next_repley_id);
			
			$info_redirect = $lang['STORED'] . '<br /><br />' . sprintf($lang['CLICK_VIEW_MESSAGE'], '<a href="'.make_url(BLOG_MODE_URL . "view". "&" . BLOG_POSTS_URL . $next_repley_id, true).'#blog-'.$next_repley_id.'">', '</a>') . '<br /><br />' . sprintf($lang['CLICK_RETURN_FORUM'], '<a href="blog.php?mode=view&b='.@$data['id'].'">', '</a>');
			message_die(GENERAL_MESSAGE, $info_redirect);
		}
		
		return $data;
	}

	function delete_blog ($mode_or_topic_id, $forum_id = null)
	{
		global $lang, $log_action;

		$log_topics = $sync_forums = array();
		
		$topic_csv = get_id_csv($mode_or_topic_id);
		
		$sql = "
			SELECT topic_id, forum_id, topic_title, topic_status
			FROM ". BB_TOPICS ."
			WHERE topic_id IN($topic_csv)
		";

		$topic_csv = array();

		foreach (DB()->fetch_rowset($sql) as $row)
		{
			$topic_csv[] = $row['topic_id'];
			$log_topics[] = $row;
			$sync_forums[$row['forum_id']] = true;
		}

		if (!$topic_csv = get_id_csv($topic_csv))
		{
			return false;
		}

		// Get topics to delete
		$tmp_delete_blog = 'tmp_delete_blog';

		DB()->query("
			CREATE TEMPORARY TABLE $tmp_delete_blog (
				topic_id MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
				PRIMARY KEY (topic_id)
			) ENGINE = MEMORY
		");

		$where_sql  = "topic_id IN($topic_csv)";

		DB()->query("
			INSERT INTO $tmp_delete_blog
				SELECT topic_id
				FROM ". BB_TOPICS ."
				WHERE $where_sql
		");

		// Get topics count
		$row = DB()->fetch_row("SELECT COUNT(*) AS topics_count FROM $tmp_delete_blog");

		if (!$deleted_topics_count = $row['topics_count'])
		{
			DB()->query("DROP TEMPORARY TABLE $tmp_delete_blog");
			return 0;
		}

		// Update user posts count
		$tmp_user_blog_posts = 'tmp_user_blog_posts';

		DB()->query("
			CREATE TEMPORARY TABLE $tmp_user_blog_posts (
				user_id    MEDIUMINT NOT NULL DEFAULT '0',
				user_posts MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
				PRIMARY KEY (user_id)
			) ENGINE = MEMORY
		");

		DB()->query("
			INSERT INTO $tmp_user_blog_posts
				SELECT p.poster_id, COUNT(p.post_id)
				FROM ". $tmp_delete_blog ." del, ". BB_POSTS ." p
				WHERE p.topic_id = del.topic_id
					AND p.poster_id != ". ANONYMOUS ."
				GROUP BY p.poster_id
		");

		DB()->query("
			UPDATE
				$tmp_user_blog_posts tmp, ". BB_USERS ." u
			SET
				u.user_posts = u.user_posts - tmp.user_posts
			WHERE
				u.user_id = tmp.user_id
		");

		DB()->query("DROP TEMPORARY TABLE $tmp_user_blog_posts");

		// Delete posts, posts_text, attachments (from DB)
		DB()->query("
			DELETE p, pt, ps, a, d, ph
			FROM      ". $tmp_delete_blog  ." del
			LEFT JOIN ". BB_POSTS            ." p  ON(p.topic_id = del.topic_id)
			LEFT JOIN ". BB_POSTS_TEXT       ." pt ON(pt.post_id = p.post_id)
			LEFT JOIN ". BB_POSTS_HTML       ." ph ON(ph.post_id = p.post_id)
		");

		// Delete topics, topics watch
		DB()->query("
			DELETE t, tw
			FROM      ". $tmp_delete_blog ." del
			LEFT JOIN ". BB_TOPICS       ." t  USING(topic_id)
		");

		// Delete topic moved stubs
		DB()->query("
			DELETE t
			FROM ". $tmp_delete_blog ." del, ". BB_TOPICS ." t
			WHERE t.topic_moved_id = del.topic_id
		");

		// Log action
		foreach ($log_topics as $row)
		{
			if ($row['topic_status'] == TOPIC_MOVED)
			{
				$row['topic_title'] = '<i>'. $lang['TOPIC_MOVED'] .'</i> '. $row['topic_title'];
			}

			$log_action->mod('blog_topic_delete', array(
				'forum_id'    => $row['forum_id'],
				'topic_id'    => $row['topic_id'],
				'topic_title' => $row['topic_title'],
			));
		}

		// Sync
		self::update_blog_info('category', array_keys($sync_forums));

		DB()->query("DROP TEMPORARY TABLE $tmp_delete_blog");

		return $deleted_topics_count;
	}


	function delete_reply ($mode_or_post_id, $user_id = null, $exclude_first = true)
	{
		global $log_action;

		$del_user_posts = ($mode_or_post_id === 'user');  // Delete all user posts

		// Get required params
		if ($del_user_posts)
		{
			if (!$user_csv = get_id_csv($user_id)) return false;
		}
		else
		{
			if (!$post_csv = get_id_csv($mode_or_post_id)) return false;

			// exclude first post of topic
			if ($exclude_first)
			{
				$sql = "SELECT blog_first_post_id FROM ". BB_BLOG_TOPICS ." WHERE blog_first_post_id IN($post_csv)";

				if ($first_posts = DB()->fetch_rowset($sql, 'blog_first_post_id'))
				{
					$posts_without_first = array_diff(explode(',', $post_csv), $first_posts);

					if (!$post_csv = get_id_csv($posts_without_first))
					{
						return false;
					}
				}
			}
		}

		// Collect data for logs, sync..
		$log_topics = $sync_forums = $sync_topics = $sync_users = array();

		if ($del_user_posts)
		{
			$sql = "SELECT DISTINCT blog_id FROM ". BB_BLOG_REPLEY ." WHERE blog_reply_user_id IN($user_csv)";

			foreach (DB()->fetch_rowset($sql) as $row)
			{
				$sync_topics[] = $row['blog_id'];
			}

			if ($topic_csv = get_id_csv($sync_topics))
			{
				$sql = "SELECT DISTINCT blog_cat_id FROM ". BB_BLOG_TOPICS ." WHERE blog_id IN($topic_csv)";

				foreach (DB()->fetch_rowset($sql) as $row)
				{
					$sync_forums[$row['blog_cat_id']] = true;
				}
			}

			$sync_users = explode(',', $user_csv);
		}
		else
		{
			$sql = "
				SELECT p.blog_id, t.blog_cat_id, t.blog_title
				FROM ". BB_BLOG_REPLEY ." p, ". BB_BLOG_TOPICS ." t
				WHERE p.blog_reply_id IN($post_csv)
					AND t.blog_id = p.blog_id
				GROUP BY t.blog_id
			";

			foreach (DB()->fetch_rowset($sql) as $row)
			{
				$log_topics[] = $row;
				$sync_topics[] = $row['blog_id'];
				$sync_forums[$row['blog_cat_id']] = true;
			}

			$sql = "SELECT DISTINCT blog_reply_user_id FROM ". BB_BLOG_REPLEY ." WHERE blog_reply_id IN($post_csv)";

			foreach (DB()->fetch_rowset($sql) as $row)
			{
				$sync_users[] = $row['blog_reply_user_id'];
			}
		}

		// Get all blog_reply_id for deleting
		$tmp_delete_blog_posts = 'tmp_delete_blog_posts';

		DB()->query("
			CREATE TEMPORARY TABLE $tmp_delete_blog_posts (
				blog_reply_id MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
				PRIMARY KEY (blog_reply_id)
			) ENGINE = MEMORY
		");
		DB()->add_shutdown_query("DROP TEMPORARY TABLE IF EXISTS $tmp_delete_blog_posts");

		if ($del_user_posts)
		{
			$where_sql = "blog_reply_user_id IN($user_csv)";

			$exclude_posts_ary = array();
			foreach (DB()->fetch_rowset("SELECT blog_first_post_id FROM ". BB_BLOG_TOPICS ." WHERE blog_autor IN($user_csv)") as $row)
			{
				$exclude_posts_ary[] = $row['blog_first_post_id'];
			}
			if ($exclude_posts_csv = get_id_csv($exclude_posts_ary))
			{
				$where_sql .= " AND blog_reply_id NOT IN($exclude_posts_csv)";
			}
		}
		else
		{
			$where_sql = "blog_reply_id IN($post_csv)";
		}

		DB()->query("
			INSERT INTO $tmp_delete_blog_posts
				SELECT blog_reply_id
				FROM ". BB_BLOG_REPLEY ."
				WHERE $where_sql
		");

		// Deleted posts count
		$row = DB()->fetch_row("SELECT COUNT(*) AS posts_count FROM $tmp_delete_blog_posts");

		if (!$deleted_posts_count = $row['posts_count'])
		{
			DB()->query("DROP TEMPORARY TABLE $tmp_delete_blog_posts");
			return 0;
		}

		// Delete posts, posts_text, attachments (from DB)
		DB()->query("
			DELETE p, pt, ph
			FROM      ". $tmp_delete_blog_posts   ." del
			LEFT JOIN ". BB_BLOG_REPLEY            ." p   ON(p.blog_reply_id  = del.blog_reply_id)
			LEFT JOIN ". BB_BLOG_REPLEY_TEXT       ." pt  ON(pt.blog_reply_id  = del.blog_reply_id)
			LEFT JOIN ". BB_BLOG_REPLEY_HTML       ." ph  ON(ph.blog_reply_id  = del.blog_reply_id)
		");


		// Log action
		if ($del_user_posts)
		{
			$log_action->admin('blog_post_delete', array(
				'log_msg' => 'user: '. get_usernames_for_log($user_id) ."<br />blog-posts: $deleted_posts_count",
			));
		}
		else if (!defined('IN_CRON'))
		{
			foreach ($log_topics as $row)
			{
				$log_action->mod('blog_post_delete', array(
					'forum_id'    => $row['blog_cat_id'],
					'topic_id'    => $row['blog_id'],
					'topic_title' => $row['blog_title'],
				));
			}
		}

		// update_blog_info
		self::update_blog_info('blog', $sync_topics);
		/*update_blog_info('user_posts', $sync_users);*/

		DB()->query("DROP TEMPORARY TABLE $tmp_delete_blog_posts");
		DB()->query("DELETE FROM ". BB_BLOG_REPLEY_HTML ." WHERE blog_reply_id = $post_csv LIMIT 1");

		return $deleted_posts_count;
	}

	function get_parsed_repley ($data)
	{

		if (!empty($data['blog_reply_html']))
		{
			return $data['blog_reply_html'];
		}

		$message = bbcode2html($data['text']);

		DB()->shutdown['blog_repley_html'][] = array(
			'blog_reply_id'   => (int) $data['blog_reply_id'],
			'blog_reply_html' => (string) $message,
		);

		return $message;
	}

	static function update_blog_info ($type, $id)
	{
		switch ($type)
		{
			case 'category':

				$all_cat = ($id === 'all');
				$category_id = implode(',', $id);
				$arr_category_id = explode(',', $category_id);

				if (!$all_cat AND !$forum_csv = get_id_csv($arr_category_id))
				{
					break;
				}

				$tmp_sync_blog_cat = 'tmp_sync_blog_cat';

				DB()->query("
						CREATE TEMPORARY TABLE $tmp_sync_blog_cat (
							blog_cat_id           SMALLINT  UNSIGNED NOT NULL DEFAULT '0',
							blog_cat_topics       MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
							PRIMARY KEY (blog_cat_id)
						) ENGINE = MEMORY
				");

				$where_sql = (!$all_cat) ? "WHERE c.blog_cat_id IN($forum_csv)" : "WHERE c.blog_cat_id IN(".get_id_csv($arr_category_id).")";

				DB()->query("
					INSERT INTO $tmp_sync_blog_cat
					SELECT
						c.blog_cat_id,
						COUNT(DISTINCT t.blog_id)
					FROM      ". BB_BLOG_CAT ." c
					LEFT JOIN ". BB_BLOG_TOPICS  ." t USING(blog_cat_id)
						$where_sql
					GROUP BY c.blog_cat_id
				");

				DB()->query("
					UPDATE
						$tmp_sync_blog_cat tmp, ". BB_BLOG_CAT ." c
					SET
						c.blog_cat_topics       = tmp.blog_cat_topics
					WHERE
						c.blog_cat_id = tmp.blog_cat_id
				");

				DB()->query("DROP TEMPORARY TABLE $tmp_sync_blog_cat");

				break;


			case 'blog':

				$all_topics = ($id === 'all');
				if (!$all_topics AND !$topic_csv = get_id_csv($id))
				{
					break;
				}

				$tmp_sync_blog = 'tmp_sync_blog';
				
				DB()->query("
					CREATE TEMPORARY TABLE $tmp_sync_blog (
						blog_id             MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
						blog_replies        MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
						blog_first_post_id  MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
						blog_last_post_id   MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
						blog_last_post_time INT       UNSIGNED NOT NULL DEFAULT '0',
						PRIMARY KEY (blog_id)
					) ENGINE = MEMORY
				");

				$where_sql = (!$all_topics) ? "AND t.blog_id IN($topic_csv)" : '';

				DB()->query("
					INSERT INTO $tmp_sync_blog
					SELECT
						t.blog_id,
						COUNT(p.blog_reply_id) AS blog_replies,
						MIN(p.blog_reply_id) AS blog_first_post_id,
						MAX(p.blog_reply_id) AS blog_last_post_id,
						MAX(p.blog_reply_time) AS blog_last_post_time
					FROM      ". BB_BLOG_TOPICS      ." t
					LEFT JOIN ". BB_BLOG_REPLEY       ." p ON(p.blog_id = t.blog_id)
					WHERE t.blog_lock != ". TOPIC_MOVED ."
						$where_sql
					GROUP BY t.blog_id
				");

				DB()->query("
					UPDATE
						$tmp_sync_blog tmp, ". BB_BLOG_TOPICS ." t
					SET
						t.blog_replies        = tmp.blog_replies,
						t.blog_first_post_id  = tmp.blog_first_post_id,
						t.blog_last_post_id   = tmp.blog_last_post_id,
						t.blog_last_post_time = tmp.blog_last_post_time
					WHERE
						t.blog_id = tmp.blog_id
				");

				$sql = "SELECT blog_id FROM ". $tmp_sync_blog ." WHERE blog_replies = 0";

				if ($rowset = DB()->fetch_rowset($sql))
				{
					$topics = array();
					foreach ($rowset as $row)
					{
						$topics[] = $row['blog_id'];
					}
					topic_delete($topics);
				}

				DB()->query("DROP TEMPORARY TABLE $tmp_sync_blog");

				// Проверка на остаточные записи об уже удаленных топиках (критично в MySQL 5.5)
				//DB()->query("DELETE FROM ". BB_BLOG_TOPICS ." WHERE blog_first_post_id NOT IN (SELECT blog_reply_id FROM ". BB_BLOG_REPLEY .")");

				break;

			/*case 'user_posts':

				$all_users = ($id === 'all');

				if (!$all_users AND !$user_csv = get_id_csv($id))
				{
					break;
				}

				$tmp_user_blog_posts = 'tmp_sync_user_blog_posts';

				DB()->query("
					CREATE TEMPORARY TABLE $tmp_user_blog_posts (
						user_id    MEDIUMINT NOT NULL DEFAULT '0',
						user_posts MEDIUMINT UNSIGNED NOT NULL DEFAULT '0',
						PRIMARY KEY (user_id)
					) ENGINE = MEMORY
				");

				// Set posts count = 0 and then update to real count
				$where_user_sql = (!$all_users) ? "AND user_id IN($user_csv)" : "AND user_posts != 0";
				$where_post_sql = (!$all_users) ? "AND blog_reply_user_id IN($user_csv)" : '';

				DB()->query("
					REPLACE INTO $tmp_user_blog_posts
						SELECT user_id, 0
						FROM ". BB_USERS ."
						WHERE user_id != ". ANONYMOUS ."
							$where_user_sql
					UNION
						SELECT blog_reply_user_id, COUNT(*)
						FROM ". BB_BLOG_REPLEY ."
						WHERE blog_reply_user_id != ". ANONYMOUS ."
							$where_post_sql
						GROUP BY blog_reply_user_id
				");

				DB()->query("
					UPDATE
						$tmp_user_blog_posts tmp, ". BB_USERS ." u
					SET
						u.user_posts = tmp.user_posts
					WHERE
						u.user_id = tmp.user_id
				");

				DB()->query("DROP TEMPORARY TABLE $tmp_user_blog_posts");

			break;*/
		}
	}

	function auth ($type, $blog_cat_id, $ug_data)
	{
		global $lang, $bf, $datastore;

		$is_guest = true;
		$is_admin = false;
		$auth = $auth_fields = $u_access = array();
		$add_auth_type_desc = ($blog_cat_id != AUTH_LIST_ALL);
		
		if ($type == AUTH_ALL)
		{
			$auth_fields = array_keys($bf['blog_auth']);
		}
		else if ($auth_type = array_search($type, $bf['blog_auth']))
		{
			$auth_fields = array($auth_type);
		}

		if (empty($auth_fields))
		{
			trigger_error(__FUNCTION__ .'(): empty $auth_fields', E_USER_ERROR);
		}
		
		if (isset($blog_cat_id))
		{
			
			if (!$blogs = $datastore->get('blog_cat_forums'))
			{
				$datastore->update('blog_cat_forums');
				$blogs = $datastore->get('blog_cat_forums');
			}
			
			if ($blog_cat_id == AUTH_LIST_ALL)
			{
				$array_count = count($blogs['forum']);
				$array_f_access = array_keys($blogs['forum']);
				for ($i = 0; $i !== $array_count; $i++) 
				{
					$f_acces[$array_f_access[$i]] = $blogs['forum'][$array_f_access[$i]];
				}
				$f_accessy = $f_acces;

			}
			else if ($blog_cat_id)
			{
				$array_f_access = explode(',', $blog_cat_id);
				$array_count = count($array_f_access);
				for ($i = 0; $i !== $array_count; $i++) 
				{
					$f_acces[] = $blogs['forum'][$array_f_access[$i]];
				}
				$arrays = $f_acces; // это ваш массив
				$resultArray = array();
				foreach ($arrays as $arr)
				{
					foreach ($arr as $k => $v)
					{
						if (!isset($resultArray[$k]) || $resultArray[$k] < $v)
						{
							$resultArray[$k] = $v;
						}	
					}
				}
				$f_accessy[$blog_cat_id] = $resultArray;
			}
		}
		if (empty($f_accessy))
		{
			trigger_error(__FUNCTION__ .'(): empty $f_accessy', E_USER_ERROR);
		}

		// GROUP mode
		if (!empty($ug_data['group_id']))
		{
			$is_guest = false;
			$is_admin = false;

			$sql = "SELECT g.*
				FROM ". BB_GROUPS ." g
				WHERE g.group_id = ". (int) $ug_data['group_id'] ."
					AND g.group_allow_blogs = 1";

			foreach (DB()->fetch_rowset($sql) as $row)
			{
				$u_access[] = $row['group_id'];
			}
		}
		else if (!empty($ug_data['user_id']))
		{
			$is_guest = empty($ug_data['session_logged_in']);
			$is_admin = (!$is_guest && $ug_data['user_level'] == ADMIN);

		}
		foreach ($f_accessy as $f_id => $f_data)
		{
			$auth[$f_id]['blog_cat_auth_mod'] = auth_check('blog_auth', 'blog_cat_auth_mod', $u_access, $f_id, $is_admin);

			foreach ($auth_fields as $auth_type)
			{
				if (!isset($f_data[$auth_type]))
				{
					continue;
				}
				switch ($f_data[$auth_type])
				{
					case AUTH_ALL:
						$auth[$f_id][$auth_type] = true;
						break;

					case AUTH_REG:
						$auth[$f_id][$auth_type] = !$is_guest;
						break;

					case AUTH_ACL:
						$auth[$f_id][$auth_type] = (auth_check('blog_auth', $auth_type, $u_access, $f_id, $is_admin) || $auth[$f_id]['blog_cat_auth_mod']);
						break;

					case AUTH_MOD:
						$auth[$f_id][$auth_type] = $auth[$f_id]['blog_cat_auth_mod'];
						break;

					case AUTH_ADMIN:
						$auth[$f_id][$auth_type] = $is_admin;
						break;

					default:
						$auth[$f_id][$auth_type] = false;
				}
				if ($add_auth_type_desc)
				{
					$auth[$f_id][$auth_type .'_type'] =& $lang['AUTH_TYPES'][$f_data[$auth_type]];
				}
			}
		}

		return ($blog_cat_id == AUTH_LIST_ALL) ? $auth : $auth[$blog_cat_id];
	}
	
	function get_category_list()
	{
		global $template, $user, $bb_cfg;
		
		$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);

		$where_sql = ($excluded_forums_csv) ? "
			WHERE blog_cat_id NOT IN($excluded_forums_csv)
		" : '';


		$sql = 'SELECT *
			FROM '. BB_BLOG_CAT ."
				$where_sql
			ORDER BY blog_cat_order, blog_cat_id";

		if (!$result = DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Couldn't get list of Categories".$excluded_forums_csv."", "", __LINE__, __FILE__, $sql);
		}else{
			$result = DB()->fetch_rowset($sql);
			foreach ($result as $row)
			{
				$image = !empty($row['blog_cat_icon']) ? $row['blog_cat_icon'] : 'folder_big.png';
				$icon = '<img src="'.$bb_cfg['dir_blog_cat_icon'].$image.'" width="25px" />';
				$template->assign_block_vars('category', array(
					'ID'			=> $row['blog_cat_id'],
					'NAME'			=> $row['blog_cat_name'],
					'TOPIC'			=> $row['blog_cat_topics'],
					'ICON'			=> $icon,
					'U_CATEGORY'	=> 'blog.php?mode=category&'. BLOG_CATEGORY_URL . urlencode($row['blog_cat_id']),
				));
			}
		}	
	}
	function get_category_select()
	{
		global $template, $user, $bb_cfg;
		
		$excluded_forums_csv = $user->get_excluded_blog(AUTH_VIEW);

		$where_sql = ($excluded_forums_csv) ? "
			WHERE blog_cat_id NOT IN($excluded_forums_csv)
		" : '';


		$sql = 'SELECT *
			FROM '. BB_BLOG_CAT ."
				$where_sql
			ORDER BY blog_cat_order, blog_cat_id";

		if (!$result = DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Couldn't get list of Categories".$excluded_forums_csv."", "", __LINE__, __FILE__, $sql);
		}else{
		$cat = array();
			$result = DB()->fetch_rowset($sql);
			if($result){
				foreach ($result as $row)
				{
					$image = !empty($row['blog_cat_icon']) ? $row['blog_cat_icon'] : 'folder_big.png';
					$cat[$row['blog_cat_name'].' ['.$row['blog_cat_topics'].']'] = $row['blog_cat_id'];
					$icon[$row['blog_cat_name'].' ['.$row['blog_cat_topics'].']']['image'] = $image;
				}
			}else{
				$icon=false;
			}
			$js = "onChange=\"document.images['blog_cat_icon_img'].src = '". $bb_cfg['dir_blog_cat_icon_s'] ."' + $('option:selected',$(this)).attr('title');\"";
			$category = build_select('category', $cat, null, null, null, $js, $icon);
			return $category;
		}	
	}
	
	function get_tag_cloud()
	{
		global $template;
		$sql = DB()->fetch_rowset('SELECT blog_topics_id, blog_tag AS tags
				FROM '.BB_BLOG_TAG.' GROUP BY blog_topics_id');
		$tags = array();
		if($sql){
			foreach($sql as $row)
			{
					if(substr_count($row['tags'], ",")>0){
						$tags[] = explode(',', $row['tags']);
					}else{
						$tags[] = explode(' ', $row['tags']);
					}
					$nums[] = $row['blog_topics_id'];
			}
			$num = count($nums);
			$tags = array_map("unserialize", array_unique(array_map("serialize", $tags)));
			$tags = call_user_func_array('array_merge', $tags);
			$factor = 0.5;

			foreach($tags AS $tag)
			{
				if($tag)
				{
					$sql = DB()->fetch_row('SELECT COUNT(blog_tag) AS numtag
							FROM ' . BB_BLOG_TAG . '
							WHERE blog_tag LIKE \'%' . $tag . '%\'');
					if($num <= 1)
					{
						$size = 10;
					}else{
						$size = round(($sql['numtag'] * 100) / $num) * $factor;
						$size = $size/2;
						$size = ($size > 20) ? 20 : $size;
						$size = ($size < 5) ? 5 : $size;
						$size = floor($size);
					}
					$full_tag = trim($tag);
					$template->assign_block_vars('tagrow', array(
						'TAG' => $tag,
						'NUM' => $sql['numtag'],
						'TAGSIZE' => floor($size) . 'pt',
						'U_TAG' => 'blog.php?mode=tag&'.BLOG_TAGS_URL . urlencode($full_tag),
					));
				}
			}
		}else{
			return false;
		}
	}
	function username_search ($search_match)
	{
		global $lang;

		$username_list = '';

		if (!empty($search_match))
		{
			$username_search = preg_replace('/\*/', '%', clean_username($search_match));

			$sql = "
				SELECT username
				FROM ". BB_USERS ."
				WHERE username = '". DB()->escape($username_search) . "'
					AND user_id <> ". ANONYMOUS ."
				LIMIT 1
			";

			if(!$row = DB()->fetch_row($sql))
			{
				bb_die('пользователь не найден');			
			}else{
				return $row['username'];
			}
		}else{
			bb_die('Введите имя');			
		}
	}
	function search_blog ($search, $minSymvol = 5, $maxSymvol = 128, $maxWords= 10)
	{
		if (strlen($search) < $minSymvol) 
		{
			bb_die('Слишком короткий поисковый запрос.');
		}
		$search = strip_tags($search);
		$search = mb_strtolower(trim($search), 'UTF-8'); //Преобразуем в нижний регистр и переводим кирилицу в UTF
		$search = preg_replace('~[^a-z0-9 \x80-\xFF]~i', "",$search); //Удаляем не нужные символы
		$search = encode_text_match($search);
		$search = preg_replace("/[\s]([^\s]{1,$minSymvol})[\s]/", " ", str_replace(" ", "  ", " ".$search." ")); //Удаление коротких слов
		$search = preg_replace('/ {2,}/',' ',$search); // убираем повторяющиеся пробелы 
		$search = substr($search, 0, $maxSymvol); //Ограничение на символы
		$search = limit_words($search, $maxWords); //Ограничение на кол-во слов
		if (strlen($search) < $minSymvol) 
		{
			bb_die('Слишком короткий поисковый запрос.');
		}
		return $search;
	}
	//ACP
	function get_info($id)
	{
		$sql = "SELECT count(*) as total
			FROM ".BB_BLOG_CAT."";
		if( !$result = DB()->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't get Forum/Category information", "", __LINE__, __FILE__, $sql);
		}
		$count = DB()->sql_fetchrow($result);
		$count = $count['total'];

		$sql = "SELECT *
			FROM ".BB_BLOG_CAT."
			WHERE blog_cat_id = $id";

		if( !$result = DB()->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't get Forum/Category information", "", __LINE__, __FILE__, $sql);
		}

		if( DB()->num_rows($result) != 1 )
		{
			message_die(GENERAL_ERROR, "Forum/Category doesn't exist or multiple forums/categories with ID $id", "", __LINE__, __FILE__);
		}

		$return = DB()->sql_fetchrow($result);
		$return['number'] = $count;
		return $return;
	}

	function renumber_order($mode, $cat = 0)
	{
		switch($mode)
		{
			case 'category':
				$table = BB_BLOG_CAT;
				$idfield = 'blog_cat_id';
				$orderfield = 'blog_cat_order';
				$cat = 0;
				break;

			default:
				message_die(GENERAL_ERROR, "Wrong mode for generating select list", "", __LINE__, __FILE__);
				break;
		}

		$sql = "SELECT * FROM $table";
		if( !empty($cat) )
		{
			$sql .= " WHERE $catfield = $cat";
		}
		$sql .= " ORDER BY $orderfield ASC";


		if( !$result = DB()->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, "Couldn't get list of Categories", "", __LINE__, __FILE__, $sql);
		}

		$i = 10;
		$inc = 10;

		while( $row = DB()->sql_fetchrow($result) )
		{
			$sql = "UPDATE $table
				SET $orderfield = $i
				WHERE $idfield = " . $row[$idfield];
			if( !DB()->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Couldn't update order fields", "", __LINE__, __FILE__, $sql);
			}
			$i += 10;
		}

	}

	function get_cat ($cat_id = FALSE)
	{
		$forums = array();
		$where_sql = '';
		
		if ($cat_id = intval($cat_id))
		{
			$where_sql = "AND blog_cat_id = $cat_id";
		}

		$sql = 'SELECT *
			FROM '. BB_BLOG_CAT ."
				$where_sql
			ORDER BY blog_cat_order, blog_cat_id";

		if (!$result = DB()->sql_query($sql))
		{
			message_die(GENERAL_ERROR, "Couldn't get list of Categories", "", __LINE__, __FILE__, $sql);
		}

		if ($rowset = DB()->sql_fetchrowset($result))
		{
			foreach ($rowset as $rid => $row)
			{
				$forums[$row['blog_cat_id']]['blog_cat_name'] = $row['blog_cat_name'];
				$forums[$row['blog_cat_id']]['f'][$row['blog_cat_id']] = $row;
				$forums[$row['blog_cat_id']]['f_ord'][$row['blog_cat_order']] = $row;
			}
		}

		return $forums;
	}

	function get_orphan_sf ()
	{
		global $cat_forums;

		$last_root = 0;
		$bad_sf_ary = array();

		foreach ($cat_forums as $cid => $c)
		{
			foreach ($c['f'] as $fid => $f)
			{
					$last_root = $f['blog_cat_id'];
			}
		}

		return implode(',', $bad_sf_ary);
	}
}

